unit pr3a;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids;

type
  TPr3 = class(TForm)
    A: TStringGrid;
    B: TStringGrid;
    X: TStringGrid;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Pr3: TPr3;

implementation

{$R *.DFM}

procedure TPr3.FormCreate(Sender: TObject);
var i, j: integer;
begin
  for i:=0 to A.RowCount-1 do
    for j:=0 to A.ColCount-1 do
      if i=j then A.Cells[j,i]:='1'
             else A.Cells[j,i]:='0';
  for i:=0 to B.RowCount-1 do B.Cells[0,i]:='1';
end;

procedure TPr3.Button1Click(Sender: TObject);
var
  ar, br, s: real;
  i, j, nr, nc: integer;
begin
  nr:=A.RowCount; {   }
  nc:=A.ColCount; {   }
  for i:=0 to B.RowCount-1 do {  }
    X.Cells[0,i]:='';
  for i:=0 to nr-1 do begin
    s:=0;
    for j:=0 to nc-1 do begin
      try {    }
        ar:=StrToFloat(A.cells[j,i]);
      except
        on E: EConvertError do
        begin { }
          A.Row:=i;A.Col:=j;
          {  }
          ActiveControl:=A;
          Showmessage('  ');
          Exit;
        end
      end;
      try {    }
        br:=StrToFloat(B.cells[0,j]);
      except
        on E: EConvertError do
        begin { }
           B.Row:=j;B.Col:=0; {  }
           ActiveControl:=B;
           Showmessage(' ');
           Exit;
        end
      end;
      try {     }
        s:=s+ar*br;
      except
        on E: EOverflow do
        begin
          Showmessage('');
          Exit;
        end
      end;
    end;
    X.Cells[0,i]:=FloatToStr(s);
  end;
end;

end.
